︠692b6d8b-1827-448a-820d-7bc7087954d2︠
# 8/12/2009
# GSC Hamilton Star DNA pooling methods as used by MP
# Quantitative testing of pipetting accuracy
#
# TEST: Dispense all mode (not dispense 3ul)
︡dcf3aa4f-9521-454d-adf7-8e22836f3732︡︡
︠18396db4-8137-43c0-ad3c-3a8e67a650ee︠
# initial weights in g (at time 0 minutes)

plt_dry = 28.039 # test plate
plc_dry = 1. # no ctrl plate
tubeA_dry = 0.945 # test tube
tip50_dry = 80.541 # 50ul tips and rack
︡1ee29b4f-68ef-4e17-a726-705b96fb9a64︡︡
︠ea6b1f38-9f26-466c-bb40-39f977c2f7b5︠
# filled quadrant 1 of plt and plc with 10ul green colored h2o
# weights before run (at time 5 minutes)

plt_filled = 28.983
plc_filled = 1.
︡7a3c8ca4-ea7e-4c64-b3b9-f3fd3fc8e84a︡︡
︠3ea93693-a56c-4c1a-9a67-6062d4f88192︠
# measured density by pipette volume 1ml of green water
tubeB_dry = 0.927
tubeB_1ml = 1.935
density = (tubeB_1ml - tubeB_dry) / 1000
print "density =", density, "g/ul"
︡57e4fc27-ad5c-4497-968d-2b91cbc208f5︡{"stdout": "density = 0.00100800000000000 g/ul"}︡
︠7a8daf9f-0305-4e74-a2aa-ce396294b63b︠
# ran pooling program 96 wells * 3ul from plt into tube A
# weights post-run at time 24 minutes

plt_postrun = 28.705
plc_postrun = 1
tubeA_postrun = 1.171
tip50_postrun = 80.568
num_wells = 96
t_postrun = 24
︡71f09488-a918-4909-aae7-6056f0c8d032︡︡
︠7ef7903a-ce53-48df-bc2d-0b6c58fb72e9︠
# measured weights later (at 48 minutes)
plt_later = 1.
plc_later = 1.
t_later = 48
︡52274013-6637-466d-8ba6-1401c55d6eb3︡︡
︠5fdfb552-3a16-410d-97a6-de50269843e7︠
# CALCULATIONS

water_plt_before_run = (plt_filled - plt_dry) / density
water_plt_after_run = (plt_postrun - plt_dry) / density
water_plc_before_run = (plc_filled - plc_dry) / density
water_plc_after_run = (plc_postrun - plc_dry) / density

print "water in plt before run =", water_plt_before_run, "ul"
print "water in plt after run =", water_plt_after_run, "ul"
print "water in plc before run =", water_plc_before_run, "ul"
print "water in plc after run =", water_plc_after_run, "ul"
︡44e19be9-4c71-4dfd-96e8-8864b2a3d5a7︡{"stdout": "water in plt before run = 936.507936507936 ul\nwater in plt after run = 660.714285714283 ul\nwater in plc before run = 0.000000000000000 ul\nwater in plc after run = 0.000000000000000 ul"}︡
︠d9eb942a-d9e3-4a8e-8e74-a7745aa89507︠
total_water_lost_from_plt = (plt_filled - plt_postrun) / density
print "total water lost from test plate plt = ", total_water_lost_from_plt, "ul"
︡38afbe28-5098-40a6-93c8-4f3df916388f︡{"stdout": "total water lost from test plate plt =  275.793650793653 ul"}︡
︠bc7ea825-7bbd-4230-99be-84179779b8f9︠
water_tubeA_after_run = (tubeA_postrun - tubeA_dry) / density
print "water in tubeA after run =", water_tubeA_after_run, "ul"
︡019df631-5aef-4f72-aef2-4f95fe162f10︡{"stdout": "water in tubeA after run = 224.206349206349 ul"}︡
︠f5cae097-4b50-4588-be3e-c9eabc85d967︠
water_tips_after_run = (tip50_postrun - tip50_dry) / density
print "water in tips after run =", water_tips_after_run, "ul"
︡c1316f2b-d9fc-4b1e-b962-5be1153b2466︡{"stdout": "water in tips after run = 26.7857142857153 ul"}︡
︠e32df601-48b2-412d-97d0-ba492d58d31b︠
water_evap_24min_plt = \
water_plt_before_run \
- water_plt_after_run \
- water_tips_after_run \
- water_tubeA_after_run

print "water lost to evaporation from test plate plt =", water_evap_24min_plt, "ul"
︡37dc8c07-2efb-4432-9762-c6699b3c77eb︡{"stdout": "water lost to evaporation from test plate plt = 24.8015873015884 ul"}︡
︠2776c46e-c83e-435d-9555-7d2346f7f2dc︠
water_evap_24min_plc = \
water_plc_before_run \
- water_plc_after_run
print "water lost to evaporation from ctrl plate plc =", water_evap_24min_plc, "ul"
︡f610e110-60d4-4342-af21-3f41735d2a39︡{"stdout": "water lost to evaporation from ctrl plate plc = 0.000000000000000 ul"}︡
︠46e06f55-0640-418c-a610-dd4acebb5444︠
# sanity check, this should be zero
print "evaporation sanity check, these should be equal."
print "total water lost from plate =", total_water_lost_from_plt, "ul"

#tube, tips, evap
print "total of calculated losses = ", \
water_tubeA_after_run + water_tips_after_run + water_evap_24min_plt, "ul"
︡897f1dfd-b5a1-4dc0-a671-0ee1eed96cf1︡{"stdout": "evaporation sanity check, these should be equal.\ntotal water lost from plate = 275.793650793653 ul\ntotal of calculated losses =  275.793650793653 ul"}︡
︠0a5f5d3b-9d0c-4597-baef-0c8f6d3e074a︠
# Break it all down on a per-well basis

print "PER-WELL CONCLUSIONS FOR A SHORT RUN"
print "water in each well at beginning of run (should be 10ul):"
print water_plt_before_run / num_wells, "ul"
print "water in each well after run (should be 7ul):"
print water_plt_after_run / num_wells, "ul"
print "water removed from plate during run (should be 3ul):"
print (water_plt_before_run - water_plt_after_run) / num_wells, "ul"
print "water per well transferred to tubeA (should be 3ul):"
print water_tubeA_after_run / num_wells, "ul"
print "water per well lost to tips:"
print water_tips_after_run / num_wells, "ul"
print "water per well lost, presumably to evaporation (at 24 minutes):"
print water_evap_24min_plt / num_wells, "ul"
︡795b7b87-4774-4e44-8f30-77ce61cd37da︡{"stdout": "PER-WELL CONCLUSIONS FOR A SHORT RUN\nwater in each well at beginning of run (should be 10ul):\n9.75529100529100 ul\nwater in each well after run (should be 7ul):\n6.88244047619044 ul\nwater removed from plate during run (should be 3ul):\n2.87285052910055 ul\nwater per well transferred to tubeA (should be 3ul):\n2.33548280423281 ul\nwater per well lost to tips:\n0.279017857142868 ul\nwater per well lost, presumably to evaporation (at 24 minutes):\n0.258349867724879 ul"}︡
︠67c6aaca-2326-4e5f-9cea-36fe87aae00a︠
# Evaporation over time as measured after the run
#BROKEN

def water_in_plt_per_well(wt_of_plt):
    return (wt_of_plt - plt_dry) / density / num_wells

water_per_well_plt_over_time = (
    water_in_plt_per_well(28.693),
    water_in_plt_per_well(28.691),
    water_in_plt_per_well(28.684),
    water_in_plt_per_well(28.667),
    )
        
timeseries = (
    24-24, 
    25-24, 
    31-24,
    41-24)
   
print ("Water in control plate over time (per well)", 
water_per_well_plt_over_time, "ul")
︡2c41fe7d-4bac-4015-9ef0-a28f61520b4a︡{"stdout": "('Water in control plate over time (per well)', (6.75843253968254, 6.73776455026452, 6.66542658730158, 6.48974867724868), 'ul')"}︡
︠47ad86d5-ab83-4167-a48b-2229d7bb6fc8︠
# now plot evaporation over time for the control plate
xypoints = [(timeseries[i], water_per_well_plt_over_time[i]) for i in range(len(timeseries))]
# xypoints.insert(0, (0,0)) # decomment to base graph at 0,0
print xypoints
show(points(xypoints))
︡3ff92152-cee0-4d2f-82fc-519bb8b55bbe︡{"stdout": "[(0, 6.75843253968254), (1, 6.73776455026452), (7, 6.66542658730158), (17, 6.48974867724868)]"}︡{"html": "<font color='black'><img src='cell://sage0.png'></font>"}︡
︠3adecd86-69ea-4bba-9361-2b1e7692c781︠
evap_rate = (water_per_well_plt_over_time[0] - water_per_well_plt_over_time[3]) / (timeseries[3] - timeseries[0]) * 60 # evaporation rate in ul / hr
print "evaporation rate: ", evap_rate, "ul/hr"
︡21649a79-1b93-40e9-a6c6-25b3d2aa11d8︡{"stdout": "evaporation rate:  0.948295985060684 ul/hr"}︡
